(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('@emotion/styled')) :
    typeof define === 'function' && define.amd ? define(['exports', 'react', '@emotion/styled'], factory) :
    (global = global || self, factory(global['react-ui-bb'] = {}, global.React, global.styled));
}(this, (function (exports, React, styled) { 'use strict';

    React = React && React.hasOwnProperty('default') ? React['default'] : React;
    styled = styled && styled.hasOwnProperty('default') ? styled['default'] : styled;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    }

    var styles = {
        font: {
            fontWeight: 'bold',
        },
        size: {
            small: {
                fontSize: 0.8,
                letterSpacing: 0.15,
            },
            medium: {
                fontSize: 1.2,
                letterSpacing: 0.3,
            },
            large: {
                fontSize: 1.5,
                letterSpacing: 0.55,
            },
        },
        button: {
            border: 'none',
            borderRadius: 0.33,
            cursor: 'pointer',
            padding: '10px 20px',
            textTransform: 'uppercase',
        },
        color: {
            primary: {
                background: 'var(--primary-background)',
                color: 'var(--primary-color)',
            },
            secondary: {
                background: 'var(--secondary-background)',
                color: 'var(--secondary-color)',
            },
            error: {
                background: 'var(--error-background)',
                color: 'var(--error-color)',
            },
        },
    };

    // https://gist.github.com/youssman/745578062609e8acac9f
    var camelCaseToDashed = function (string) {
        return string.replace(/([a-z])([A-Z])/g, '$1-$2').toLowerCase();
    };
    var convertStyleObjectToCSS = function (styleObject) {
        return Object.entries(styleObject).map(function (_a) {
            var styleKey = _a[0], styleValue = _a[1];
            return camelCaseToDashed(styleKey) + ": " + (isNaN(styleValue) ? styleValue : styleValue + "rem") + ";";
        });
    };

    var float = '2px';
    var Wrapper = styled.button(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n    ", ";\n    font-weight: ", ";\n    ", ";\n    ", "\n    outline: none;\n    transition: transform 0.5s cubic-bezier(0.1, 1.51, 1, 1.22);\n    &:hover {\n        -webkit-transform: translateY(-", ");\n        transform: translateY(-", ");\n    }\n    &:active {\n        -webkit-transform: translateY(", ");\n        transform: translateY(", ");\n    }\n"], ["\n    ", ";\n    font-weight: ", ";\n    ", ";\n    ", "\n    outline: none;\n    transition: transform 0.5s cubic-bezier(0.1, 1.51, 1, 1.22);\n    &:hover {\n        -webkit-transform: translateY(-", ");\n        transform: translateY(-", ");\n    }\n    &:active {\n        -webkit-transform: translateY(", ");\n        transform: translateY(", ");\n    }\n"])), convertStyleObjectToCSS(styles.button), styles.font.fontWeight, function (_a) {
        var _b = _a.color, color = _b === void 0 ? '' : _b;
        return styles.color[color];
    }, function (_a) {
        var theme = _a.theme;
        return convertStyleObjectToCSS(theme);
    }, float, float, float, float);
    var Button = function (_a) {
        var onClick = _a.onClick, text = _a.text, children = _a.children, color = _a.color, size = _a.size;
        return (React.createElement(Wrapper, { color: color, onClick: onClick, theme: styles.size[size] },
            children,
            text));
    };
    Button.defaultProps = {
        color: 'primary',
        disabled: false,
        fullWidth: false,
        loading: false,
        iconPosition: 'start',
        shape: 'square',
        size: 'medium',
        text: '',
        variant: 'contained',
    };
    var templateObject_1;

    exports.Button = Button;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
